
:-use_module(library(lists)).



main :-
	generate(1).


	
generate(301) :- !.

generate(Number):-
	number_codes(Number, NumberCode),
	append("step", NumberCode, FileName),
	append(FileName, ".cpl", FileNameCPL),
	atom_codes(FileNameCPLAtom, FileNameCPL),
	open(FileNameCPLAtom, write, Stream),
	write_clauses(Stream),
	write_graph(0, Number, Stream),	
	close(Stream),
	Next is Number + 1,
	generate(Next).



write_clauses(Stream):-
	format(Stream, "~npath(Node, Node).~npath(Source, Target): 0.3 :- edge(Source, Node), path(Node, Target).~n~n", []).



write_graph(Last, Last, Stream) :- !.

write_graph(Number, Last, Stream):-
	Next is Number + 1,
	format(Stream, "edge(0, ~d): 0.3.~n", [Next]), 
	write_path(Next, Next, Stream),
	write_graph(Next, Last, Stream).



write_path(1, _Last, _Stream) :- !. 

write_path(Number, Last, Stream) :-
	Prev is Number - 1,
	format(Stream, "edge(~d, ~d): 0.3.~n", [Last, Prev]), 
	write_path(Prev, Last, Stream).
